from collections import Counter
from functools import reduce
from time import time
import pickle

print(start_time := time())
xs = []
with open('GCF_000001405.40_GRCh38.p14_genomic.fna') as f:
    # hlavičku přeskočíme
    next(f)
    # další řádky zpracujeme
    for i,line in enumerate(f, start=1):
        xs.append(Counter(line.strip()))
print(time())                       # (274 s)
xs = reduce(lambda x,y: x+y, xs)    # (941 s)
print(end_time := time())
print(end_time - start_time)    # 1216 s

print()

print(start_time := time())
with open('data.pickle', 'bw') as f:
    pickle.dump(xs, f)
print(end_time := time())
print(end_time - start_time)    # 0.009 s
