from collections import Counter
from time import time
import pickle

print(start_time := time())
xs = []
with open('GCF_000001405.40_GRCh38.p14_genomic.fna') as f:
    # hlavičku přeskočíme
    next(f)
    # další řádky zpracujeme
    for i,line in enumerate(f, start=1):
        xs.append(Counter(line.strip()))
print(end_time := time())
print(end_time - start_time)    # 269 s

print()

print(start_time := time())
with open('data.pickle', 'bw') as f:
    pickle.dump(xs, f)
print(end_time := time())
print(end_time - start_time)    # ?? s
