import mmap
from collections import Counter
import pickle
from time import time

print(start_time := time())
xs = Counter()
with open('GCF_000001405.40_GRCh38.p14_genomic.fna', 'r') as f:
    with mmap.mmap(f.fileno(), 0, access=mmap.ACCESS_READ) as m:
        # hlavičku přeskočíme
        next(f)
        # další řádky zpracujeme
        for i,line in enumerate(f, start=1):
            xs += Counter(line.strip())
print(end_time := time())
print(end_time - start_time)    # 0.006 s

print()

print(start_time := time())
with open('data_mmap.pickle', 'bw') as f:
    pickle.dump(xs, f)
print(end_time := time())
print(end_time - start_time)    # ?? s
